diff --git a/backup/util/dbops/restore_dbops.class.php b/backup/util/dbops/restore_dbops.class.php
index bd00c32..d3b0ea5 100644
--- a/backup/util/dbops/restore_dbops.class.php
+++ b/backup/util/dbops/restore_dbops.class.php
@@ -29,39 +29,6 @@
  */
 abstract class restore_dbops {
     /**
-     * Keep cache of backup records.
-     * @var array
-     * @todo MDL-25290 static should be replaced with MUC code.
-     */
-    private static $backupidscache = array();
-    /**
-     * Keep track of backup ids which are cached.
-     * @var array
-     * @todo MDL-25290 static should be replaced with MUC code.
-     */
-    private static $backupidsexist = array();
-    /**
-     * Count is expensive, so manually keeping track of
-     * backupidscache, to avoid memory issues.
-     * @var int
-     * @todo MDL-25290 static should be replaced with MUC code.
-     */
-    private static $backupidscachesize = 2048;
-    /**
-     * Count is expensive, so manually keeping track of
-     * backupidsexist, to avoid memory issues.
-     * @var int
-     * @todo MDL-25290 static should be replaced with MUC code.
-     */
-    private static $backupidsexistsize = 10240;
-    /**
-     * Slice backupids cache to add more data.
-     * @var int
-     * @todo MDL-25290 static should be replaced with MUC code.
-     */
-    private static $backupidsslice = 512;
-
-    /**
      * Return one array containing all the tasks that have been included
      * in the restore process. Note that these tasks aren't built (they
      * haven't steps nor ids data available)
@@ -158,7 +125,7 @@ abstract class restore_dbops {
     /**
      * Precheck the loaded roles, return empty array if everything is ok, and
      * array with 'errors', 'warnings' elements (suitable to be used by restore_prechecks)
-     * with any problem found. At the same time, store all the mapping into backup_ids_temp
+     * with any problem found. At the same time, store all the mapping into backup_ids cache
      * and also put the information into $rolemappings (controller->info), so it can be reworked later by
      * post-precheck stages while at the same time accept modified info in the same object coming from UI
      */
@@ -168,8 +135,10 @@ abstract class restore_dbops {
         $problems = array(); // To store warnings/errors
 
         // Get loaded roles from backup_ids
-        $rs = $DB->get_recordset('backup_ids_temp', array('backupid' => $restoreid, 'itemname' => 'role'), '', 'itemid, info');
-        foreach ($rs as $recrole) {
+        $cache = backup_muc_manager::get('role');
+        $rs = $cache->get_store()->find_all();
+        foreach ($rs as $itemid) {
+            $recrole = (object) $cache->get($itemid);
             // If the rolemappings->modified flag is set, that means that we are coming from
             // manually modified mappings (by UI), so accept those mappings an put them to backup_ids
             if ($rolemappings->modified) {
@@ -194,7 +163,6 @@ abstract class restore_dbops {
                 }
             }
         }
-        $rs->close();
         return $problems;
     }
 
@@ -205,45 +173,18 @@ abstract class restore_dbops {
      * @param string $itemname name of the item
      * @param int $itemid id of item
      * @return array backup id's
-     * @todo MDL-25290 replace static backupids* with MUC code
      */
     protected static function get_backup_ids_cached($restoreid, $itemname, $itemid) {
-        global $DB;
-
-        $key = "$itemid $itemname $restoreid";
+        $cache_ids = backup_muc_manager::get('' . $itemname);
 
         // If record exists in cache then return.
-        if (isset(self::$backupidsexist[$key]) && isset(self::$backupidscache[$key])) {
-            // Return a copy of cached data, to avoid any alterations in cached data.
-            return clone self::$backupidscache[$key];
-        }
-
-        // Clean cache, if it's full.
-        if (self::$backupidscachesize <= 0) {
-            // Remove some records, to keep memory in limit.
-            self::$backupidscache = array_slice(self::$backupidscache, self::$backupidsslice, null, true);
-            self::$backupidscachesize = self::$backupidscachesize + self::$backupidsslice;
-        }
-        if (self::$backupidsexistsize <= 0) {
-            self::$backupidsexist = array_slice(self::$backupidsexist, self::$backupidsslice, null, true);
-            self::$backupidsexistsize = self::$backupidsexistsize + self::$backupidsslice;
-        }
-
-        // Retrive record from database.
-        $record = array(
-            'backupid' => $restoreid,
-            'itemname' => $itemname,
-            'itemid'   => $itemid
-        );
-        if ($dbrec = $DB->get_record('backup_ids_temp', $record)) {
-            self::$backupidsexist[$key] = $dbrec->id;
-            self::$backupidscache[$key] = $dbrec;
-            self::$backupidscachesize--;
-            self::$backupidsexistsize--;
-            return $dbrec;
-        } else {
-            return false;
+        $result = $cache_ids->get($itemid);
+        if ($result) {
+            $result = (object) $result;
+            $result->itemname = $itemname;
+            $result->itemid = $itemid;
         }
+        return $result;
     }
 
     /**
@@ -254,12 +195,9 @@ abstract class restore_dbops {
      * @param int $itemid id of item
      * @param array $extrarecord extra record which needs to be updated
      * @return void
-     * @todo MDL-25290 replace static BACKUP_IDS_* with MUC code
      */
     protected static function set_backup_ids_cached($restoreid, $itemname, $itemid, $extrarecord) {
-        global $DB;
-
-        $key = "$itemid $itemname $restoreid";
+        $cache = backup_muc_manager::get('' . $itemname);
 
         $record = array(
             'backupid' => $restoreid,
@@ -268,30 +206,16 @@ abstract class restore_dbops {
         );
 
         // If record is not cached then add one.
-        if (!isset(self::$backupidsexist[$key])) {
-            // If we have this record in db, then just update this.
-            if ($existingrecord = $DB->get_record('backup_ids_temp', $record)) {
-                self::$backupidsexist[$key] = $existingrecord->id;
-                self::$backupidsexistsize--;
-                self::update_backup_cached_record($record, $extrarecord, $key, $existingrecord);
-            } else {
-                // Add new record to cache and db.
-                $recorddefault = array (
+        if (!$cache->get($itemid)) {
+            // Add new record to cache.
+            $recorddefault = array (
                     'newitemid' => 0,
                     'parentitemid' => null,
                     'info' => null);
-                $record = array_merge($record, $recorddefault, $extrarecord);
-                $record['id'] = $DB->insert_record('backup_ids_temp', $record);
-                self::$backupidsexist[$key] = $record['id'];
-                self::$backupidsexistsize--;
-                if (self::$backupidscachesize > 0) {
-                    // Cache new records if we haven't got many yet.
-                    self::$backupidscache[$key] = (object) $record;
-                    self::$backupidscachesize--;
-                }
-            }
+            $record = array_merge($record, $recorddefault, $extrarecord);
+            $cache->set($itemid, $record);
         } else {
-            self::update_backup_cached_record($record, $extrarecord, $key);
+            self::update_backup_cached_record($record, $extrarecord);
         }
     }
 
@@ -303,27 +227,22 @@ abstract class restore_dbops {
      * @param string $key unique key which is used to identify cached record
      * @param stdClass $existingrecord (optional) existing record
      */
-    protected static function update_backup_cached_record($record, $extrarecord, $key, $existingrecord = null) {
-        global $DB;
+    protected static function update_backup_cached_record($record, $extrarecord, $existingrecord = null) {
+        $cache = backup_muc_manager::get('' . $record['itemname']);
         // Update only if extrarecord is not empty.
         if (!empty($extrarecord)) {
-            $extrarecord['id'] = self::$backupidsexist[$key];
-            $DB->update_record('backup_ids_temp', $extrarecord);
             // Update existing cache or add new record to cache.
-            if (isset(self::$backupidscache[$key])) {
-                $record = array_merge((array)self::$backupidscache[$key], $extrarecord);
-                self::$backupidscache[$key] = (object) $record;
-            } else if (self::$backupidscachesize > 0) {
+            if ($cache->get($record['itemid'])) {
+                $trecord = array_merge($cache->get($record['itemid']), $extrarecord);
+            } else {
                 if ($existingrecord) {
-                    self::$backupidscache[$key] = $existingrecord;
+                    $trecord = $existingrecord;
                 } else {
-                    // Retrive record from database and cache updated records.
-                    self::$backupidscache[$key] = $DB->get_record('backup_ids_temp', $record);
+                    $trecord = array();
                 }
-                $record = array_merge((array)self::$backupidscache[$key], $extrarecord);
-                self::$backupidscache[$key] = (object) $record;
-                self::$backupidscachesize--;
+                $trecord = array_merge($record, $extrarecord);
             }
+            $cache->set($record['itemid'], $trecord);
         }
     }
 
@@ -338,18 +257,9 @@ abstract class restore_dbops {
      * (drop & restore) of the table that may happen once the prechecks have ended. All
      * the rest of operations are always routed via {@link set_backup_ids_record()}, 1 by 1,
      * keeping the caches on sync.
-     *
-     * @todo MDL-25290 static should be replaced with MUC code.
      */
     public static function reset_backup_ids_cached() {
         // Reset the ids cache.
-        $cachetoadd = count(self::$backupidscache);
-        self::$backupidscache = array();
-        self::$backupidscachesize = self::$backupidscachesize + $cachetoadd;
-        // Reset the exists cache.
-        $existstoadd = count(self::$backupidsexist);
-        self::$backupidsexist = array();
-        self::$backupidsexistsize = self::$backupidsexistsize + $existstoadd;
     }
 
     /**
@@ -701,14 +611,16 @@ abstract class restore_dbops {
      * that level are returned
      */
     public static function restore_get_question_banks($restoreid, $contextlevel = null) {
-        global $DB;
-
         $results = array();
-        $qcats = $DB->get_recordset_sql("SELECT itemid, parentitemid AS contextid, info
-                                         FROM {backup_ids_temp}
-                                       WHERE backupid = ?
-                                         AND itemname = 'question_category'", array($restoreid));
-        foreach ($qcats as $qcat) {
+        $cache = backup_muc_manager::get('question_category');
+        $qcats = $cache->get_store()->find_all();
+        foreach ($qcats as $catid) {
+            $temp = $cache->get($catid);
+            $qcat = (object) array(
+                    'itemid' => $catid,
+                    'contextid' => $temp['parentitemid'],
+                    'info' => $temp['info'],
+                    );
             // If this qcat context haven't been acummulated yet, do that
             if (!isset($results[$qcat->contextid])) {
                 $info = backup_controller_dbops::decode_backup_temp_info($qcat->info);
@@ -718,7 +630,6 @@ abstract class restore_dbops {
                 }
             }
         }
-        $qcats->close();
         // Sort by value (contextlevel from CONTEXT_SYSTEM downto CONTEXT_MODULE)
         asort($results);
         return $results;
@@ -732,15 +643,16 @@ abstract class restore_dbops {
         global $DB;
 
         $results = array();
-        $qcats = $DB->get_recordset_sql("SELECT itemid, info
-                                         FROM {backup_ids_temp}
-                                        WHERE backupid = ?
-                                          AND itemname = 'question_category'
-                                          AND parentitemid = ?", array($restoreid, $contextid));
-        foreach ($qcats as $qcat) {
-            $results[$qcat->itemid] = backup_controller_dbops::decode_backup_temp_info($qcat->info);
+        $cache = backup_muc_manager::get('question_category');
+        $qcats = $cache->get_store()->find_all();
+        foreach ($qcats as $qcat_id) {
+            $qcat = $cache->get($qcat_id);
+            if ($qcat['parentitemid'] != $contextid) {
+                continue;
+            }
+
+            $results[$qcat_id] = backup_controller_dbops::decode_backup_temp_info($qcat['info']);
         }
-        $qcats->close();
 
         return $results;
     }
@@ -831,15 +743,16 @@ abstract class restore_dbops {
         global $DB;
 
         $results = array();
-        $qs = $DB->get_recordset_sql("SELECT itemid, info
-                                      FROM {backup_ids_temp}
-                                     WHERE backupid = ?
-                                       AND itemname = 'question'
-                                       AND parentitemid = ?", array($restoreid, $qcatid));
-        foreach ($qs as $q) {
-            $results[$q->itemid] = backup_controller_dbops::decode_backup_temp_info($q->info);
+        $cache = backup_muc_manager::get('question');
+        $qs = $cache->get_store()->find_all();
+        foreach ($qs as $q_id) {
+            $q = $cache->get($q_id);
+            if ($q['parentitemid'] != $qcatid) {
+                continue;
+            }
+
+            $results[$q_id] = backup_controller_dbops::decode_backup_temp_info($q['info']);
         }
-        $qs->close();
         return $results;
     }
 
@@ -889,56 +802,51 @@ abstract class restore_dbops {
             $newcontextid = $newcontextrecord->newitemid;
         }
 
-        // Sometimes it's possible to have not the oldcontextids stored into backup_ids_temp->parentitemid
-        // columns (because we have used them to store other information). This happens usually with
-        // all the question related backup_ids_temp records. In that case, it's safe to ignore that
-        // matching as far as we are always restoring for well known oldcontexts and olditemids
-        $parentitemctxmatchsql = ' AND i.parentitemid = f.contextid ';
-        if ($skipparentitemidctxmatch) {
-            $parentitemctxmatchsql = '';
-        }
-
         // Important: remember how files have been loaded to backup_files_temp
         //   - info: contains the whole original object (times, names...)
         //   (all them being original ids as loaded from xml)
 
-        // itemname = null, we are going to match only by context, no need to use itemid (all them are 0)
-        if ($itemname == null) {
-            $sql = "SELECT id AS bftid, contextid, component, filearea, itemid, itemid AS newitemid, info
-                      FROM {backup_files_temp}
-                     WHERE backupid = ?
-                       AND contextid = ?
-                       AND component = ?
-                       AND filearea  = ?";
-            $params = array($restoreid, $oldcontextid, $component, $filearea);
-
-        // itemname not null, going to join with backup_ids to perform the old-new mapping of itemids
-        } else {
-            $sql = "SELECT f.id AS bftid, f.contextid, f.component, f.filearea, f.itemid, i.newitemid, f.info
-                      FROM {backup_files_temp} f
-                      JOIN {backup_ids_temp} i ON i.backupid = f.backupid
-                                              $parentitemctxmatchsql
-                                              AND i.itemid = f.itemid
-                     WHERE f.backupid = ?
-                       AND f.contextid = ?
-                       AND f.component = ?
-                       AND f.filearea = ?
-                       AND i.itemname = ?";
-            $params = array($restoreid, $oldcontextid, $component, $filearea, $itemname);
-            if ($olditemid !== null) { // Just process ONE olditemid intead of the whole itemname
-                $sql .= ' AND i.itemid = ?';
-                $params[] = $olditemid;
-            }
-        }
-
         $fs = get_file_storage();         // Get moodle file storage
         $basepath = $basepath . '/files/';// Get backup file pool base
         // Report progress before query.
         if ($progress) {
             $progress->progress();
         }
-        $rs = $DB->get_recordset_sql($sql, $params);
-        foreach ($rs as $rec) {
+
+        $files_cache = backup_muc_manager::get('file_temp');
+        $rs = $files_cache->get_store()->find_all();
+
+        if ($itemname !== null) {
+            $ids_cache = backup_muc_manager::get('' . $itemname);
+        }
+        foreach ($rs as $rec_id) {
+            $rec = $files_cache->get($rec_id);
+            // Filter out items we don't want.
+            if ($rec->contextid != $oldcontextid || $rec->component != $component || $rec->filearea != $filearea) {
+                continue;
+            }
+            // If itemname = null, we are going to match only by context, no need to use itemid (all them are 0)
+            // itemname not null, going to compare with backup_ids to perform the old-new mapping of itemids
+            if (is_null($itemname)) {
+                $rec->newitemid = $rec->itemid;
+            } else {
+                $id_item = $ids_cache->get($rec->itemid);
+
+                // Sometimes it's possible to have not the oldcontextids stored into backup_ids_temp->parentitemid
+                // columns (because we have used them to store other information). This happens usually with
+                // all the question related backup_ids_temp records. In that case, it's safe to ignore that
+                // matching as far as we are always restoring for well known oldcontexts and olditemids
+                if (!$id_item || (!$skipparentitemidctxmatch && $rec->contextid != $id_item['parentitemid'])) {
+                    continue;
+                }
+
+                // Specific olditemid?
+                if (!is_null($olditemid) && $rec->itemid != $olditemid) {
+                    continue;
+                }
+
+                $rec->newitemid = $id_item['newitemid'];
+            }
             // Report progress each time around loop.
             if ($progress) {
                 $progress->progress();
@@ -1033,11 +941,8 @@ abstract class restore_dbops {
 
                 // store the the new contextid and the new itemid in case we need to remap
                 // references to this file later
-                $DB->update_record('backup_files_temp', array(
-                    'id' => $rec->bftid,
-                    'newcontextid' => $newcontextid,
-                    'newitemid' => $rec->newitemid), true);
-
+                $rec->newcontextid = $newcontextid;
+                $files_cache->set($rec_id, $rec);
             } else {
                 // this is an alias - we can't create it yet so we stash it in a temp
                 // table and will let the final task to deal with it
@@ -1052,7 +957,6 @@ abstract class restore_dbops {
                 }
             }
         }
-        $rs->close();
         return $results;
     }
 
@@ -1097,8 +1001,14 @@ abstract class restore_dbops {
         $themes    = get_list_of_themes(); // Get themes for quick search later
 
         // Iterate over all the included users with newitemid = 0, have to create them
-        $rs = $DB->get_recordset('backup_ids_temp', array('backupid' => $restoreid, 'itemname' => 'user', 'newitemid' => 0), '', 'itemid, parentitemid, info');
-        foreach ($rs as $recuser) {
+        $user_cache = backup_muc_manager::get('user');
+        $rs = $user_cache->get_store()->find_all();
+        foreach ($rs as $uid) {
+            $recuser = (object) $user_cache->get($uid);
+            if ($recuser->newitemid) {
+                continue;
+            }
+
             $progress->progress();
             $user = (object)backup_controller_dbops::decode_backup_temp_info($recuser->info);
 
@@ -1182,7 +1092,7 @@ abstract class restore_dbops {
 
             // Done, let's create the user and annotate its id
             $newuserid = $DB->insert_record('user', $user);
-            self::set_backup_ids_record($restoreid, 'user', $recuser->itemid, $newuserid);
+            self::set_backup_ids_record($restoreid, 'user', $uid, $newuserid);
             // Let's create the user context and annotate it (we need it for sure at least for files)
             // but for deleted users that don't have a context anymore (MDL-30192). We are done for them
             // and nothing else (custom fields, prefs, tags, files...) will be created.
@@ -1248,7 +1158,6 @@ abstract class restore_dbops {
                         $recuser->parentitemid, $userid, null, null, null, false, $progress);
             }
         }
-        $rs->close();
         $progress->end_progress();
     }
 
@@ -1512,15 +1421,16 @@ abstract class restore_dbops {
         }
 
         // Prepare for reporting progress.
-        $conditions = array('backupid' => $restoreid, 'itemname' => 'user');
-        $max = $DB->count_records('backup_ids_temp', $conditions);
+        $user_cache = backup_muc_manager::get('user');
+        $rs = $user_cache->get_store()->find_all();
+        $max = sizeof($rs);
         $done = 0;
         $progress->start_progress('Checking users', $max);
 
         // Iterate over all the included users
-        $rs = $DB->get_recordset('backup_ids_temp', $conditions, '', 'itemid, info');
-        foreach ($rs as $recuser) {
-            $user = (object)backup_controller_dbops::decode_backup_temp_info($recuser->info);
+        foreach ($rs as $uid) {
+            $recuser =  $user_cache->get($uid);
+            $user = (object)backup_controller_dbops::decode_backup_temp_info($recuser['info']);
 
             // Find the correct mnethostid for user before performing any further check
             if (empty($user->mnethosturl) || $user->mnethosturl === $CFG->wwwroot) {
@@ -1539,14 +1449,14 @@ abstract class restore_dbops {
 
             if (is_object($usercheck)) { // No problem, we have found one user in DB to be mapped to
                 // Annotate it, for later process. Set newitemid to mapping user->id
-                self::set_backup_ids_record($restoreid, 'user', $recuser->itemid, $usercheck->id);
+                self::set_backup_ids_record($restoreid, 'user', $uid, $usercheck->id);
 
             } else if ($usercheck === false) { // Found conflict, report it as problem
                  $problems[] = get_string('restoreuserconflict', '', $user->username);
 
             } else if ($usercheck === true) { // User needs to be created, check if we are able
                 if ($cancreateuser) { // Can create user, set newitemid to 0 so will be created later
-                    self::set_backup_ids_record($restoreid, 'user', $recuser->itemid, 0, null, (array)$user);
+                    self::set_backup_ids_record($restoreid, 'user', $uid, 0, null, (array)$user);
 
                 } else { // Cannot create user, report it as problem
                     $problems[] = get_string('restorecannotcreateuser', '', $user->username);
@@ -1558,7 +1468,6 @@ abstract class restore_dbops {
             $done++;
             $progress->progress($done);
         }
-        $rs->close();
         $progress->end_progress();
         return $problems;
     }
@@ -1613,11 +1522,14 @@ abstract class restore_dbops {
 
     public static function set_backup_files_record($restoreid, $filerec) {
         global $DB;
+        static $num_calls = 0;
 
         // Store external files info in `info` field
         $filerec->info     = backup_controller_dbops::encode_backup_temp_info($filerec); // Encode the whole record into info.
-        $filerec->backupid = $restoreid;
-        $DB->insert_record('backup_files_temp', $filerec);
+
+        $cache = backup_muc_manager::get('file_temp');
+        $this_key = str_replace('-', '_', md5(json_encode($filerec)));
+        $cache->set($this_key, $filerec);
     }
 
     public static function set_backup_ids_record($restoreid, $itemname, $itemid, $newitemid = 0, $parentitemid = null, $info = null) {
@@ -1686,14 +1598,17 @@ abstract class restore_dbops {
         // Get the course context
         $coursectx = context_course::instance($courseid);
         // Get all the mapped roles we have
-        $rs = $DB->get_recordset('backup_ids_temp', array('backupid' => $restoreid, 'itemname' => 'role'), '', 'itemid, info, newitemid');
-        foreach ($rs as $recrole) {
-            $info = backup_controller_dbops::decode_backup_temp_info($recrole->info);
+
+        $role_cache = backup_muc_manager::get('role');
+        $rs = $role_cache->get_store()->find_all();
+        foreach ($rs as $recrole_id) {
+            $recrole = $role_cache->get($recrole_id);
+            $info = backup_controller_dbops::decode_backup_temp_info($recrole['info']);
             // If it's one mapped role and we have one name for it
-            if (!empty($recrole->newitemid) && !empty($info['nameincourse'])) {
+            if (!empty($recrole['newitemid']) && !empty($info['nameincourse'])) {
                 // If role name doesn't exist, add it
                 $rolename = new stdclass();
-                $rolename->roleid = $recrole->newitemid;
+                $rolename->roleid = $recrole['newitemid'];
                 $rolename->contextid = $coursectx->id;
                 if (!$DB->record_exists('role_names', (array)$rolename)) {
                     $rolename->name = $info['nameincourse'];
@@ -1701,7 +1616,6 @@ abstract class restore_dbops {
                 }
             }
         }
-        $rs->close();
     }
 
     /**
diff --git a/backup/util/dbops/tests/restore_dbops_test.php b/backup/util/dbops/tests/restore_dbops_test.php
index d0fd2cc..a74f812 100644
--- a/backup/util/dbops/tests/restore_dbops_test.php
+++ b/backup/util/dbops/tests/restore_dbops_test.php
@@ -67,37 +67,6 @@ class restore_dbops_testcase extends advanced_testcase {
         $this->assertSame(null, $result->parentitemid);
         $this->assertSame(null, $result->info);
 
-        // Drop the backup_xxx_temp temptables manually, so memory cache won't be invalidated.
-        $dbman->drop_table(new xmldb_table('backup_ids_temp'));
-        $dbman->drop_table(new xmldb_table('backup_files_temp'));
-
-        // Verify the mapping continues returning the same info,
-        // now from cache (the table does not exist).
-        $result = restore_dbops::get_backup_ids_record($restoreid, $mapping->itemname, $mapping->itemid);
-        $this->assertSame($mapping->itemname, $result->itemname);
-        $this->assertSame($mapping->itemid, $result->itemid);
-        $this->assertSame(0, $result->newitemid);
-        $this->assertSame(null, $result->parentitemid);
-        $this->assertSame(null, $result->info);
-
-        // Recreate the temp table, just to drop it using the restore API in
-        // order to check that, then, the cache becomes invalid for the same request.
-        restore_controller_dbops::create_restore_temp_tables($restoreid);
-        restore_controller_dbops::drop_restore_temp_tables($restoreid);
-
-        // No cached info anymore, so the mapping request will arrive to
-        // DB leading to error (temp table does not exist).
-        try {
-            $result = restore_dbops::get_backup_ids_record($restoreid, $mapping->itemname, $mapping->itemid);
-            $this->fail('Expecting an exception, none occurred');
-        } catch (Exception $e) {
-            $this->assertTrue($e instanceof dml_exception);
-            $this->assertSame('Table "backup_ids_temp" does not exist', $e->getMessage());
-        }
-
-        // Create the backup_ids temp tables once more.
-        restore_controller_dbops::create_restore_temp_tables($restoreid);
-
         // Send one mapping using the public api with complete values.
         restore_dbops::set_backup_ids_record($restoreid, $mapping->itemname, $mapping->itemid,
                 $mapping->newitemid, $mapping->parentitemid, $mapping->info);
@@ -109,7 +78,7 @@ class restore_dbops_testcase extends advanced_testcase {
         $this->assertSame($mapping->parentitemid, $result->parentitemid);
         $this->assertSame($mapping->info, $result->info);
 
-        // Finally, drop the temp tables properly and get the DB error again (memory caches empty).
+        // Finally, drop the temp cache and get the DB error (memory caches empty).
         restore_controller_dbops::drop_restore_temp_tables($restoreid);
         try {
             $result = restore_dbops::get_backup_ids_record($restoreid, $mapping->itemname, $mapping->itemid);
diff --git a/backup/util/helper/muc_helper.class.php b/backup/util/helper/muc_helper.class.php
new file mode 100644
index 0000000..518bfc9
--- /dev/null
+++ b/backup/util/helper/muc_helper.class.php
@@ -0,0 +1,62 @@
+<?php
+
+// This file is part of Moodle - http://moodle.org/
+//
+// Moodle is free software: you can redistribute it and/or modify
+// it under the terms of the GNU General Public License as published by
+// the Free Software Foundation, either version 3 of the License, or
+// (at your option) any later version.
+//
+// Moodle is distributed in the hope that it will be useful,
+// but WITHOUT ANY WARRANTY; without even the implied warranty of
+// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+// GNU General Public License for more details.
+//
+// You should have received a copy of the GNU General Public License
+// along with Moodle.  If not, see <http://www.gnu.org/licenses/>.
+
+/**
+ * @package    moodlecore
+ * @subpackage backup-helper
+ * @copyright  2015 Catalyst-IT
+ * @author     Nigel Cunningham
+ * @license    http://www.gnu.org/copyleft/gpl.html GNU GPL v3 or later
+ */
+
+abstract class backup_muc_manager {
+    private static $stores = array();
+
+    /**
+     * get - get a MUC per-request cache for this itemname
+     */
+    public static function get($itemname)
+    {
+        if (!isset(self::$stores[$itemname])) {
+            self::$stores[$itemname] = true;
+        }
+
+        return cache::make_from_params(cache_store::MODE_REQUEST, 'core', 'backup_' . $itemname,
+                array(), array('simplekeys' => true));
+    }
+
+    /**
+     * get_stores - get a list of stores that we have instantiated
+     */
+    public static function get_stores()
+    {
+        return self::$stores;
+    }
+
+    /**
+     * reset - clear all stores and forget them
+     */
+    public static function reset()
+    {
+        foreach (self::get_stores() as $store) {
+            $cache = self::get($store);
+            $store->purge();
+        }
+
+        self::$stores = array();
+    }
+}
